#include "ros/ros.h"
#include "std_msgs/String.h"
#include "ScanerAPI/scanerAPI_DLL_C.h" //SCANeRTM API: C language Functions
#include "ScanerAPI/ScanerAPImessagesNetwork.h" //SCANeRTM API: Network utils
#include "ScanerAPI/ScanerAPImessagesShm.h"
#include <sstream>



int main(int argc, char **argv)
{
	std_msgs::String msg;
	std::stringstream ss;
	float speed=0.0;
	ros::init(argc, argv, "scanerAPI_sample_ros_receive");
	ros::NodeHandle p;
	Process_Init(argc, argv); //SCANeRTM API: Process initialization
	//Instantiation of  the publisher, it will send data msg to the calculator
	ros::Publisher speed_pub = p.advertise<std_msgs::String>("speed_sensed", 100000);

	//Definition on a vehicle interface to get any data from the vehicle 
	DataInterface* vehicle_0_in = Com_declareInputData(NETWORK_IVEHICLE_VEHICLEUPDATE, 0);

	while (ros::ok())
	{
		Process_Wait(); //SCANeRTM API: Frequency synchronization
		Process_Run(); //SCANeRTM API: Run the process
		if (Process_GetState() == PS_RUNNING) //SCANeRTM API: The simulation is running
		{
			Com_updateInputs(UT_AllData); //SCANeRTM API: Update input data (data to read)
			speed=Com_getFloatData(vehicle_0_in, "speed[0]")*3.6; //SCANeRTM API: Read vehicle 0’s speed on X;//SCANeRTM API: Read vehicle 0’s speed.
			ss << speed;
			msg.data = ss.str();
			ss.str("");
			//Here we show the value on the terminal to check it first before sending it
			ROS_INFO("%s", msg.data.c_str());
			//Here we publish the value to the calculator node
			speed_pub.publish(msg);
			ros::spinOnce();
		}
	}
	Process_Close(); //SCANeRTM API: Clean way to stop the SCANeRTM module
	return 0;
}
