#include "ros/ros.h"
#include "std_msgs/String.h"
#include "ScanerAPI/scanerAPI_DLL_C.h" //SCANeRTM API: C language Functions
#include "ScanerAPI/ScanerAPImessagesNetwork.h" //SCANeRTM API: Network utils
#include "ScanerAPI/ScanerAPImessagesShm.h"
#include <sstream>

unsigned int value_received ;

//Test function and acquisition of the value computedby the calculator node
void chatterCallback(const std_msgs::String::ConstPtr& msg)
{
	std::istringstream myStream (msg->data.c_str());
	myStream >> value_received ;
	//To demonstrate that the communicaiton works fine, we illustrate it by showing the value received divided by 5. 
	std::cout << "The value received divided by 5 is : " << value_received/5 << std::endl ;
}

int main(int argc, char **argv)
{
	ros::init(argc, argv, "scanerAPI_sample_ros_transmit");
	ros::NodeHandle n;
	Process_Init(argc, argv); //SCANeRTM API: Process initialization
	ros::Subscriber sub_to_calculator = n.subscribe("response", 1000, chatterCallback);
	bool isOk1=false;

	DataInterface* vehicle_0_model_corrective_out = Com_declareOutputData(SHM_MODELCABIN_CABTOMODELCORRECTIVE, 0);

	while (ros::ok())
	{
		Process_Wait(); //SCANeRTM API: Frequency synchronization	
		Process_Run(); //SCANeRTM API: Run the process
		if (Process_GetState() == PS_RUNNING) //SCANeRTM API: The simulation is running
		{

			//Example of treatment after receiving a value from SCaner (In this big example it is the speed but it would be a sensor value
			// in real conditions)
			if(value_received>5){
				Com_setDoubleData(vehicle_0_model_corrective_out,"AcceleratorAdditive",(double)value_received);
				Com_setDoubleData(vehicle_0_model_corrective_out,"AcceleratorMultiplicative",0.0);
				Com_setDoubleData(vehicle_0_model_corrective_out,"BrakeAdditive",50.0);
				Com_setDoubleData(vehicle_0_model_corrective_out,"BrakeMultiplicative",0.0);
			}
			
			Com_updateOutputs(UT_AllData);
			//ROS_INFO("%s", msg.data.c_str());
			ros::spinOnce();
		}
	}
	Process_Close(); //SCANeRTM API: Clean way to stop the SCANeRTM module
	return 0;
}

